CHMOD(1)

NOM
chmod - Modifier les autorisations d'accès à un fichier

SYNOPSIS
chmod [options] mode fichier...

Options POSIX : [-R] [--]

Mode GNU : [--reference= ficref ]

Options GNU (forme courte) : [-cfvR] [--help] [--version] [--]

DESCRIPTION
chmod modifie les permissions d'accès de chacun des fichiers indiqués, en suivant l'indication de mode, qui peut être une représentation symbolique du changement à effectuer, ou un nombre octal représentant le motif binaire des nouvelles autorisations.

Le format symbolique des changements de mode est « [ugoa...][[+-=][rwxXstugo...]...][,...] ». Plusieurs opérations symboliques peuvent être séparées par des virgules.

Une combinaison des lettres « ugoa » contrôle la catégorie d'accès à modifier. Il peut s'agir de l'utilisateur possédant le fichier (u), des autres utilisateurs du même groupe que le fichier (g), des utilisateurs n'appartenant pas au groupe du fichier (o), ou de tous les utilisateurs (a). Si aucune catégorie n'est indiquée, l'ensemble (a) est pris par défaut, mais les bits correspondant à des bits à 1 du umask ne sont pas affectés.

L'opérateur « + » autorise un accès, l'opérateur « - » interdit un accès, et l'opérateur « = » autorise exclusivement l'accès indiqué.

Les lettres « rwxXstugo » sélectionne le type d'autorisation concernée :

r   lecture,

w   écriture,

x   exécution (ou parcours pour les répertoires),

X   exécution, uniquement si le fichier est un répertoire, ou s'il a déjà une autorisation d'exécution pour une des catégories d'utilisateur (s'il s'agit donc bien d'un fichier exécutable),

s   utiliser l'ID du propriétaire ou du groupe propriétaire du fichier lors de l'exécution,

t   (sticky-bit) conserver le code du programme sur le périphérique de swap après exécution. Il s'agit du comportement original, mais de nos jours il sert uniquement pour les répertoires. Il indique que seuls le propriétaire du répertoire, et le propriétaire d'un fichier qui s'y trouve ont le droit de supprimer ce fichier. C'est typiquement utilisé pour les répertoires comme /tmp ayant une autorisation d'écriture générale.

u   les permissions dont dispose actuellement le propriétaire du fichier,

g   les permissions dont disposent actuellement les autres membres du groupe propriétaire du fichier,

o   les permissions dont disposent tous les autres utilisateurs.

Une valeur numérique pour le mode est constituée de 1 à 4 chiffres en octal (0 a 7), calculés en additionnant les bits de valeurs 4, 2, et 1. Un bit non mentionné étant considéré comme nul. Le premier chiffre correspond aux attributs Set-UID (4), Set-GID (2), et conservation du code en mémoire [« sticky bit »] (1). Le second chiffre correspond aux autorisations de lecture (4), écriture (2) et exécution pour l'utilisateur propriétaire du fichier. Les troisième et quatrième chiffres correspondent respectivement aux autorisations d'accès pour les membres du groupe du fichier, et pour les autres utilisateurs.

chmod ne modifie jamais les autorisations d'accès des liens symboliques, l'appel système chmod(2) ne peut pas les modifier. Ceci n'est pas un problème puisque ces autorisations ne sont jamais prises en compte. En fait, chmod modifie les autorisations d'accès du fichier cible du lien symbolique à condition que le lien soit explicitement mentionné sur la ligne de commande. En revanche, chmod ignore purement et simplement les liens symboliques qu'il rencontre lors des descentes récursives de répertoires.

OPTIONS POSIX

-R  Modifier récursivement les autorisations des répertoires et de leurs contenus.

--  Indique la fin explicite de la liste des options.

DESCRIPTION GNU SUPPLÉMENTAIRE
Une extension GNU (ajoutée avec les outils fileutils 4.0) permet d'utiliser --reference=ficref comme description de mode : le mode sera le même que celui du fichier ficref.

OPTIONS GNU

-c, --changes
    Ne décrire que les fichiers dont les permissions ont réellement changé.

-f, --silent, --quiet
    Ne pas afficher de messages d'erreurs concernant les fichiers dont les autorisations n'ont pas pu être modifiées.

-v, --verbose
    Décrire les modifications apportées.

-R, --recursive
    Modifier récursivement les autorisations des répertoires et de leurs contenus.

OPTIONS GNU STANDARDS

--help
    Afficher un message d'aide, et terminer normalement.

--version
    Afficher le numéro de version et terminer normalement.

ENVIRONNEMENT
LANG, LC_ALL, LC_CTYPE et LC_MESSAGES ont leurs significations habituelles. Pour les systèmes conformes XSI : NLSPATH a sa signification habituelle.

CONFORMITÉ
POSIX.2 ne documente que l'option -R. Toutes les autres options peuvent ne pas être portables. POSIX ne décrit pas l'utilisation du bit « t » (sticky). Le standard ne précise pas non plus si chmod doit préserver la cohérence en effaçant ou en refusant de positionner les bits Set-UID ou Set-GID si tous les bits d'exécution sont effacés.

MODES NON STANDARDS
Nous avons décrit plus haut le comportement du bit « t » sur les répertoires. Chaque système attache une signification personnelle à ce bit. En particulier Linux adopte le comportement de System V (voir SVID version 3), en utilisant le bit Set-GID des fichiers sans autorisation d'exécution pour le groupe comme un verrou. Pour plus de détails, voyez le fichier /usr/src/linux/Documentation/mandatory.txt.

NOTES
Cette page décrit la version de chmod que l'on rencontre dans le paquetage fileutils-4.0. D'autres versions peuvent varier légèrement.

VOIR AUSSI
chattr(1), chown(1), install(1), chmod(2), stat(2), umask(2)

TRADUCTION

Ce document est une traduction réalisée par Christophe Blaess <http://www.blaess.fr/christophe/> le 29 novembre 1996 et révisée le 19 novembre 2007.

L'équipe de traduction a fait le maximum pour réaliser une adaptation française de qualité. La version anglaise la plus à jour de ce document est toujours consultable via la commande : « LANG=C man 1 chmod ». N'hésitez pas à signaler à l'auteur ou au traducteur, selon le cas, toute erreur dans cette page de manuel.